#!/bin/sh
#------------------------------------------------------------------------------
# ========= |
# \\ / F ield | OpenFOAM: The Open Source CFD Toolbox
# \\ / O peration |
# \\ / A nd | Copyright (C) 2011-2016 OpenFOAM Foundation
# \\/ M anipulation | Copyright (C) 2016-2017 OpenCFD Ltd.
#------------------------------------------------------------------------------
# License
# This file is part of OpenFOAM.
#
# OpenFOAM is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with OpenFOAM. If not, see .
#
# Script
# foamConfigurePaths
#
# Description
# Adjust hardcoded versions and installation paths (for bash, POSIX shell).
#
#------------------------------------------------------------------------------
usage() {
exec 1>&2
while [ "$#" -ge 1 ]; do echo "$1"; shift; done
cat<&2
echo
echo "Error encountered:"
while [ "$#" -ge 1 ]; do echo " $1"; shift; done
echo
echo "See '${0##*/} -help' for usage"
echo
exit 1
}
# Check if argument matches the expected input. Respects case.
# Uses sed for consistency with the replacement routines.
#
# _matches [... ]
#
_matches()
{
local input="$1"
shift
local result
for regexp
do
result=$(echo "$input" | sed -n -e "/^$regexp"'$/p')
test -n "$result" && return 0 # successful match
done
return 1
}
# Function to do replacement on file. Checks if any replacement has been done.
# _inlineSed
_inlineSed()
{
local file="$1"
local regexp="$2"
local replacement="$3"
local msg="$4"
local cmd='/^[^#]/s@'"$regexp"'@'"$replacement"'@'
[ -f "$file" ] || {
echo "Missing file: $file"
exit 2 # Fatal
}
grep -q "$regexp" "$file" && sed -i -e "$cmd" "$file" || { \
echo "Failed: ${msg:-replacement} in $file"
return 1
}
[ -n "$msg" ] && echo " $msg ($file)"
return 0
}
# Standard type of replacements.
# replace ..
# looks for KEYWORD=.*
replace()
{
local file="$1"
shift
local key
local val
while [ "$#" -ge 2 ]
do
key=$1
val=$2
shift 2
_inlineSed \
$file \
"$key=.*" \
"$key=$val" \
"Replaced $key setting by '$val'"
done
}
#------------------------------------------------------------------------------
unset adjusted optMpi
# Parse options
while [ "$#" -gt 0 ]
do
case "$1" in
-h | -help | --help)
usage
;;
'')
# Discard empty arguments
;;
-foamInstall | --foamInstall)
# Replace FOAM_INST_DIR=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
foamInstDir="$2"
_inlineSed \
etc/bashrc \
'\(.*BASH_SOURCE.*\)' \
'## \1' \
"Remove default FOAM_INST_DIR setting" \
&& _inlineSed \
etc/bashrc \
'\(.* && FOAM_INST_DIR\)' \
'## \1'
_inlineSed \
etc/bashrc \
'^ *FOAM_INST_DIR=.*' \
'FOAM_INST_DIR='"$foamInstDir" \
"Setting FOAM_INST_DIR to '$foamInstDir'"
adjusted=true
shift
;;
-projectName | --projectName)
# Replace WM_PROJECT_DIR=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
projectName="$2"
_inlineSed \
etc/bashrc \
'WM_PROJECT_DIR=.*' \
'WM_PROJECT_DIR=$WM_PROJECT_INST_DIR/'"$projectName" \
"Replaced WM_PROJECT_DIR setting by $projectName"
adjusted=true
shift
;;
-foamVersion | --projectVersion)
# Replace WM_PROJECT_VERSION=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/bashrc WM_PROJECT_VERSION "$2"
adjusted=true
shift
;;
-archOption | --archOption)
# Replace WM_ARCH_OPTION=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
_matches "$2" 32 64 || die "'$1' option has bad value: '$2'"
optionValue="$2"
if [ "$optionValue" = "$(sed -ne '/^[^#]/s/^.* WM_ARCH_OPTION=//p' etc/bashrc)" ]
then
echo "WM_ARCH_OPTION already set to $optionValue"
: ${adjusted:=false}
else
replace etc/bashrc WM_ARCH_OPTION "$optionValue"
adjusted=true
fi
shift
;;
-int32 | -int64)
# Replace WM_LABEL_SIZE=...
optionValue="${1#-int}"
replace etc/bashrc WM_LABEL_SIZE "$optionValue"
adjusted=true
;;
-SP | -DP)
# Replace WM_PRECISION_OPTION=...
optionValue="${1#-}"
replace etc/bashrc WM_PRECISION_OPTION "$optionValue"
adjusted=true
;;
-system)
# Replace WM_COMPILER_TYPE=... and WM_COMPILER=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/bashrc WM_COMPILER_TYPE system WM_COMPILER "$2"
adjusted=true
shift
;;
-third | -ThirdParty)
# Replace WM_COMPILER_TYPE=... and WM_COMPILER=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/bashrc WM_COMPILER_TYPE ThirdParty WM_COMPILER "$2"
adjusted=true
shift
;;
-boost)
# Replace boost_version=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/CGAL boost_version "$2"
adjusted=true
shift
;;
-boost-path)
# Replace BOOST_ARCH_PATH=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/CGAL BOOST_ARCH_PATH "$2"
adjusted=true
shift
;;
-cgal)
# Replace cgal_version=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/CGAL cgal_version "$2"
adjusted=true
shift
;;
-cgal-path)
# Replace CGAL_ARCH_PATH=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/CGAL CGAL_ARCH_PATH "$2"
adjusted=true
shift
;;
-fftw)
# Replace fftw_version=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/FFTW fftw_version "$2"
adjusted=true
shift
;;
-fftw-path)
# Replace FFTW_ARCH_PATH=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/FFTW FFTW_ARCH_PATH "$2"
adjusted=true
shift
;;
-clang)
# Replace clang_version=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/compiler clang_version "$2"
adjusted=true
shift
;;
-cmake)
# Replace cmake_version=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/paraview cmake_version "$2"
adjusted=true
shift
;;
-mpi)
# Explicitly set WM_MPLIB=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/bashrc WM_MPLIB "$2"
optMpi=system
adjusted=true
shift
;;
-openmpi)
# Replace FOAM_MPI=openmpi-.. and set to use third-party
# The edit is slightly fragile, but works
expected="openmpi-[1-9][.0-9]*"
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
optMpi="$2"
_matches "$optMpi" "$expected" || die "'$1' option has bad value: '$optMpi'"
_inlineSed etc/config.sh/mpi \
"FOAM_MPI=$expected" \
"FOAM_MPI=$optMpi" \
"Replaced 'FOAM_MPI=$expected' setting by 'FOAM_MPI=$optMpi'"
replace etc/bashrc WM_MPLIB OPENMPI
adjusted=true
shift
;;
-openmpi-system)
# Explicitly set WM_MPLIB=SYSTEMOPENMPI
replace etc/bashrc WM_MPLIB SYSTEMOPENMPI
optMpi=system
adjusted=true
;;
-openmpi-third)
# Explicitly set WM_MPLIB=OPENMPI, using default setting for openmpi
replace etc/bashrc WM_MPLIB OPENMPI
optMpi=third
adjusted=true
;;
-paraview | -paraviewVersion | --paraviewVersion)
# Replace ParaView_VERSION=...
expected="[5-9][.0-9]*"
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
_matches "$2" "$expected" || die "'$1' option has bad value: '$2'"
replace etc/config.sh/paraview ParaView_VERSION "$2"
adjusted=true
shift
;;
-paraview-path | -paraviewInstall | --paraviewInstall)
# Replace ParaView_DIR=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/paraview ParaView_DIR "$2"
adjusted=true
shift
;;
-metis)
# Replace METIS_VERSION=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/metis METIS_VERSION "$2"
adjusted=true
shift
;;
-metis-path)
# Replace METIS_ARCH_PATH=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/metis METIS_ARCH_PATH "$2"
adjusted=true
shift
;;
-scotch | -scotchVersion | --scotchVersion)
# Replace SCOTCH_VERSION=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/scotch SCOTCH_VERSION "$2"
adjusted=true
shift
;;
-scotch-path | -scotchArchPath | --scotchArchPath)
# Replace SCOTCH_ARCH_PATH=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/scotch SCOTCH_ARCH_PATH "$2"
adjusted=true
shift
;;
-vtk)
# Replace vtk_version=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/vtk vtk_version "$2"
adjusted=true
shift
;;
-mesa)
# Replace mesa_version=...
[ "$#" -ge 2 ] || die "'$1' option requires an argument"
replace etc/config.sh/vtk mesa_version "$2"
adjusted=true
shift
;;
gmp-[4-9]* | gmp-system)
# gcc-related package
replace etc/config.sh/compiler gmp_version "$1"
adjusted=true
;;
mpfr-[2-9]* | mpfr-system)
# gcc-related package
replace etc/config.sh/compiler mpfr_version "$1"
adjusted=true
;;
mpc-[0-9]* | mpc-system)
# gcc-related package
replace etc/config.sh/compiler mpc_version "$1"
adjusted=true
;;
-sigfpe)
# Enable FOAM_SIGFPE handling
_inlineSed etc/bashrc \
"[a-z][a-z]* FOAM_SIGFPE.*" \
"export FOAM_SIGFPE=" \
"Activate FOAM_SIGFPE handling"
;;
-no-sigfpe)
# Disable FOAM_SIGFPE handling
_inlineSed etc/bashrc \
"[a-z][a-z]* FOAM_SIGFPE.*" \
"unset FOAM_SIGFPE" \
"Deactivate FOAM_SIGFPE handling"
;;
*)
die "unknown option/argument: '$1'"
;;
esac
shift
done
if [ "$adjusted" = false ]
then
echo "Nothing adjusted"
exit 0
elif [ -z "$adjusted" ]
then
die "Please specify at least one configure option"
fi
#------------------------------------------------------------------------------